package client


import (
	"log"
	"cosync/internal/core"
	"net"
	"strconv"
)

//TODO: handle errors, review logging
func Run() {

	log.Println("Loading config")
	
	// Loading config into program
	err := core.LoadConfig()
	if err != nil {
		log.Fatal(err)
		panic(err)
	}
	config := core.GetConfig()

	log.Println("Loaded")

	serverAddress := config["server"].(string)
	serverPort := strconv.Itoa(config["port"].(int))

	log.Println("Connecting to server")

	// Connect to the server
	conn, err := net.Dial("tcp", serverAddress + ":" + serverPort)
	if err != nil {
		log.Fatal(err)
		panic(err)
	}
	defer conn.Close()
	
	log.Println("Connected")

	conn.Write([]byte("Hello server"))
}