package core

import (
	"time"
)

type File struct {
	ID              string
	ParentDirectory Folder
	Metadata        FileMetadata
	State           SynchronizationState
}

type FileMetadata struct {
	Name         string
	Size         int64
	ModifiedTime time.Time
	Hash         string // For comparing file content
}

type SynchronizationState struct {
	Status    string // "pending", "in_progress", "completed", "error"
	Progress  float64
	LastError error
}

type Folder struct {
	ID				string
	Files			[]File
	Subfolders		[]Folder
	
	Name 			string
	Path			string
}